package com.misccraft.mod;

import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.projectile.EntityThrowable;
import net.minecraft.util.MovingObjectPosition;
import net.minecraft.util.MovingObjectPosition.MovingObjectType;
import net.minecraft.world.World;

public class EntityBouncingBall extends EntityThrowable {

	private double explosionRadius = 1.5F;
	private double miniExplosionRadius = 0.1F;
		private int numberOfBounces;
		
	    public EntityBouncingBall(World par1World)
	    {
	        super(par1World);
	       // setVelocity(1,1,1);
	        numberOfBounces=0;
	    }
	    
	    public EntityBouncingBall(World par1World, EntityLivingBase par2EntityLivingBase)
	    {
	    	super(par1World, par2EntityLivingBase);

	     	float speed=0.4F;
	        motionX *= speed;
	        motionY *= speed;
	        motionZ *= speed;
	        numberOfBounces=0;
	    }
	    
	    public EntityBouncingBall(World par1World, double par2, double par4, double par6)
	    {
	        super(par1World, par2, par4, par6);
	        numberOfBounces=0;
	    }
	    
	    @Override
	    protected void onImpact(MovingObjectPosition par1MovingObjectPosition){
// 		this.worldObj.setWorldTime(299);
	    	//spawnEntityInWorld(p_72838_1_);
	    	//createExplosion(this, this.posX, this.posY, this.posZ, (float)this.explosionRadius, true);  
	  //     setVelocity(-0.4F,-0.4F,-0.4F);
	    	if (par1MovingObjectPosition.typeOfHit==MovingObjectType.ENTITY)
	    	{
	    		this.worldObj.createExplosion(this, this.posX, this.posY, this.posZ, (float)this.explosionRadius, true);
	    		this.setDead();
	    	}
	    	if (par1MovingObjectPosition.typeOfHit==MovingObjectType.BLOCK)
	    	{
	    		numberOfBounces++;
	    		if (numberOfBounces>10) 
	    		{
		    		this.worldObj.createExplosion(this, this.posX, this.posY, this.posZ, (float)this.miniExplosionRadius, true);
	    			this.setDead();
	    		}
	    		//2 = North (face of block), 3 = South, 4 = West, 5 = East, 0 = Bottom, 1 = Top (0 and 1 were correct)
	    		if ((par1MovingObjectPosition.sideHit==0) ||(par1MovingObjectPosition.sideHit==1))  
	    				this.motionY *= -0.9F;
	    		if ((par1MovingObjectPosition.sideHit==2) ||(par1MovingObjectPosition.sideHit==3))  
    				this.motionZ *= -0.9F;
	    		if ((par1MovingObjectPosition.sideHit==4) ||(par1MovingObjectPosition.sideHit==5))  
    				this.motionX *= -0.9F;
	    		
	    	}

	    }
	}	



	
//
//public EntityBoncingBall(World p_i1755_1_)
//  {
//	super(p_i1755_1_);
//  } 
//
//public EntityBoncingBall(World p_i1755_1_, EntityLivingBase p_i1755_2_,
//		EntityLivingBase p_i1755_3_, float p_i1755_4_, float p_i1755_5_) {
//	
//	super(p_i1755_1_, p_i1755_2_, p_i1755_3_, p_i1755_4_, p_i1755_5_);
//}
//
//
//public EntityBoncingBall(World p_i1755_1_, EntityLivingBase p_i1755_2_,
//		float p_i1755_4_) {
//	super(p_i1755_1_, p_i1755_2_,  p_i1755_4_);
//}
//
////Is an EntityArrow in everything except from the following things:	
//@Override
//public void setDamage(double p_70239_1_)
//{
//	super.setDamage(1);
//
//	super.setKnockbackStrength(1000);
//}
//@Override
//public void setDead() 
//{
//	super.setDead();
//}
//}

